diff -Naur --exclude=CVS --exclude=configs linux/hpc/div.c linux-openmosix/hpc/div.c
--- linux/hpc/div.c	1970-01-01 01:00:00.000000000 +0100
+++ linux-openmosix/hpc/div.c	2003-06-13 23:54:29.000000000 +0200
@@ -0,0 +1,124 @@
+/* Changes since Feb 12 2002, copyright by Moshe Bar
+ * Copyright (C) 2000, 2001, Amnon Barak (amnon@cs.huji.ac.il)
+ *
+ * Permission to use this software is hereby granted under the terms of the
+ * GNU General Public License, as published by the Free Software Foundation.
+ *
+ * Author(s): Amnon Shiloh, Moshe Bar
+ */
+
+
+#define	low(x)	(((unsigned int *)&x)[0])
+#define	high(x)	(((unsigned int *)&x)[1])
+
+/* the slow division by 64-bit is only provided for copleteness */
+/* but is not expected to be actually ever required by the kernel except for 64bit platforms*/
+unsigned long long
+__slowdivdi3(unsigned long long a, unsigned long long b)
+{
+	long long result = 0;
+	long long bit = 1;
+
+	while((b << 1) < a)
+	{
+		b <<= 1;
+		bit <<= 1;
+	}
+	while(bit)
+	{
+		if(a > b)
+		{
+			a -= b;
+			result |= bit;
+		}
+		b >>= 1;
+		bit >>= 1;
+	}
+	return(result);
+}
+
+long long
+__divdi3(long long a, long long b)
+{
+	int sign;
+	long long result;
+	unsigned int al, ah, dl, dh;
+	int hd;
+	long long bit;
+	int i;
+
+	if(!high(b) && !high(a))	/* by far the most common case */
+		return(low(a) / low(b));
+	sign = 1;
+	if(high(b) & 0x80000000)
+	{
+		b = -b;
+		if(!high(b) && !high(a))
+			return(-low(a) / low(b));
+		sign = -1;
+	}
+	if(high(a) & 0x80000000)
+	{
+		sign = -sign;
+		a = -a;
+		if(!high(a) && !high(b))
+			return(sign * low(a) / low(b));
+	}
+	dh = high(b);
+	if(dh)
+		return(sign * __slowdivdi3(a, b));
+	dl = low(b);
+	if(!dl)
+		dh /= dl;	/* divide by 0! */
+	al = low(a);
+	ah = high(a);
+	for(i = 0 ; dh < ah || (dh == ah && dl <= al) ; i++)
+	{
+		dh += dh;
+		if(dl & 0x80000000)
+			dh++;
+		dl += dl;
+		if(i)
+		{
+			high(b) <<= 1;
+			if(low(b) & 0x80000000)
+				high(b)++;
+			low(b) <<= 1;
+		}
+	}
+	if(i == 0)
+		return(0);
+	if(i <= 32)
+	{
+		low(bit) = 1 << (i-1);
+		high(bit) = 0;
+	}
+	else
+	{
+		low(bit) = 0;
+		high(bit) = 1 << (i-33);
+	}
+	result = 0;
+	while(i--)
+	{
+		hd = high(a) - high(b);
+		if((hd = high(a) - high(b)) >= 0 &&
+			(low(a) >= low(b) || hd--))
+		{
+			high(a) = hd;
+			low(a) = low(a) - low(b);
+			result |= bit;
+		}
+		low(bit) >>= 1;
+		if(high(bit) == 1)
+			low(bit) = 0x80000000;
+		high(bit) >>= 1;
+		low(b) >>= 1;
+		if(high(b) & 1)
+			low(b) |= 0x80000000;
+		high(b) >>= 1;
+	}
+	if(sign < 0)
+		result = -result;
+	return(result);
+}
diff -Naur --exclude=CVS --exclude=configs linux/hpc/export.c linux-openmosix/hpc/export.c
--- linux/hpc/export.c	1970-01-01 01:00:00.000000000 +0100
+++ linux-openmosix/hpc/export.c	2003-09-10 20:50:13.000000000 +0200
@@ -0,0 +1,46 @@
+/* Changes since Feb 12, 2002 by Moshe Bar
+ * Copyright (C) 2000, 2001, Amnon Barak (amnon@cs.huji.ac.il)
+ *
+ * Permission to use this software is hereby granted under the terms of the
+ * GNU General Public License, as published by the Free Software Foundation.
+ *
+ * Author(s): Moshe Bar, Amnon Shiloh.
+ */
+
+
+#include <linux/config.h>
+#include <linux/module.h>
+#include <linux/sched.h>
+#include <asm/uaccess.h>
+#include <linux/hpc.h>
+#include <hpc/routines.h>
+
+EXPORT_SYMBOL(deputy_copy_to_user);
+EXPORT_SYMBOL(deputy_copy_from_user);
+EXPORT_SYMBOL(deputy_clear_user);
+EXPORT_SYMBOL(deputy_strncpy_from_user);
+EXPORT_SYMBOL(deputy_strnlen_user);
+EXPORT_SYMBOL(deputy_verify_write);
+EXPORT_SYMBOL(mosix_deputy_init_aout_mm);
+EXPORT_SYMBOL(mosix_obtain_registers);
+EXPORT_SYMBOL(mosix_deputy_setup_args);
+EXPORT_SYMBOL(mosix_deputy_dump_thread);
+EXPORT_SYMBOL(mosix_config_get_table);
+EXPORT_SYMBOL(adjust_task_mosix_context);
+
+#ifdef CONFIG_MOSIX_DFSA
+EXPORT_SYMBOL(dfsa_open_file);
+EXPORT_SYMBOL(dfsa_touch_file);
+EXPORT_SYMBOL(dfsa_close_file);
+#endif /* CONFIG_MOSIX_DFSA */
+
+#if !defined(DO_NOT_FIX_LINUX_BUGS)
+#include <linux/personality.h>
+EXPORT_SYMBOL(lookup_exec_domain);
+#endif
+
+#ifdef CONFIG_DRM_I810_MODULE
+extern asmlinkage long sys_munmap(unsigned long,size_t);
+EXPORT_SYMBOL(mosix_go_home);
+EXPORT_SYMBOL(sys_munmap);
+#endif /* CONFIG_DRM_I810_MODULE */
diff -Naur --exclude=CVS --exclude=configs linux/hpc/freemem.c linux-openmosix/hpc/freemem.c
--- linux/hpc/freemem.c	1970-01-01 01:00:00.000000000 +0100
+++ linux-openmosix/hpc/freemem.c	2002-11-24 21:57:58.000000000 +0100
@@ -0,0 +1,443 @@
+/* Changes since Feb 12, 2002 by Moshe Bar
+ * Copyright (C) 2000, 2001, Amnon Barak (amnon@cs.huji.ac.il)
+ *
+ * Permission to use this software is hereby granted under the terms of the
+ * GNU General Public License, as published by the Free Software Foundation.
+ *
+ * Author(s): Amnon Shiloh, Moshe Bar
+ */
+
+#include <linux/sched.h>
+#include <linux/mm.h>
+#include <linux/pagemap.h>
+#include <linux/swap.h>
+#include <linux/swapctl.h>
+#include <linux/smp_lock.h>
+#include <linux/delay.h>
+#include <linux/hpc.h>
+#include <linux/slab.h>
+#include <asm/pgtable.h>
+#include <hpc/routines.h>
+#include <hpc/debug.h>
+#include <hpc/defs.h>
+#include <hpc/balance.h>
+
+int pages_to_keep_free;
+int latest_free_mem;
+static int sort_age_maxchunk;
+static int marker;
+
+static inline int
+current_free_mem(void)
+{
+        return(latest_free_mem);
+}
+
+int
+export_mem(void)
+{
+	register int i, n;
+	struct task_struct *p;
+
+	n = current_free_mem() - pages_to_keep_free;
+	read_lock(&tasklist_lock);
+	for_each_task(p)
+	if((i = p->mosix.pages_i_bring) > 0)
+		n -= i;
+	read_unlock(&tasklist_lock);
+	if(n < 0)
+		n = 0;
+	return(n);
+}
+
+int
+memory_badly_required(void)
+{
+	register int n, s = 0;
+	struct task_struct *p;
+	struct mm_struct *mm;
+
+	n = current_free_mem() - pages_to_keep_free;
+	write_lock_irq(&tasklist_lock);
+	++marker;
+	for_each_task(p)
+	{
+		n -= p->mosix.pages_i_bring;
+		task_lock(p);
+		if((mm = p->mm) && mm->mark != marker && mm->last_memsort)
+		{
+			s += mm->swapped;
+			mm->mark = marker;
+		}
+		task_unlock(p);
+	}
+	write_unlock_irq(&tasklist_lock);
+	if(n < 0 && n > -MIN_EXPECTED_PROC_SIZE)
+		n = -MIN_EXPECTED_PROC_SIZE;
+	if(n < 0)
+		n -= s;
+	return(-n);
+}
+
+#define	MDP_HIGHEST_QUALITY	(MIN_EXPECTED_PROC_SIZE * 10)
+
+/* "memory_relief_quality" is called with tasklist_lock read-locked */
+int
+memory_relief_quality(struct task_struct *p, int need)
+{
+	int q;
+	int used, unused, swapped;	/* (dirty pages only) */
+	struct mm_struct *mm;
+
+	read_lock(&tasklist_lock);
+	task_lock(p);
+	if(!(mm = p->mm) || !mm->last_memsort)
+	{
+		task_unlock(p);
+		read_unlock(&tasklist_lock);
+		return(0);
+	}
+	used = mm->used;
+	unused = mm->unused;
+	swapped = mm->swapped;
+	task_unlock(p);
+	read_unlock(&tasklist_lock);
+	if (used >= need && used < 2 * need)
+		q = MDP_HIGHEST_QUALITY * (150 - used * 50 / need) / 100;
+	else if(used >= need)
+		q = MDP_HIGHEST_QUALITY * need / (1 + used - need);
+	else if (used < need)
+	{
+		if(need > MDP_HIGHEST_QUALITY/2)
+			q = MDP_HIGHEST_QUALITY / 2 * used / need;
+		else
+			q = used;
+	}
+	if(swapped)
+		q = q * used / (used + swapped);
+
+	return(q);
+}
+
+/*
+ * The memory-sorting daemon is only loosely connected with MOSIX:
+ * it should have been part of Linux, but Linux does not age pages
+ * belonging to processes (unless memory is under pressure) and in
+ * openMosix we do need to know how much memory is really free ALL THE TIME.
+ * The code here is largely stolen from "mm/vmscan.c".
+ */
+
+void
+compute_freemem(void)
+{
+	int count;
+	static int trouble_time;
+	int kernel, inactive;
+	unsigned int tasked;
+
+	if(acpuse < MF * smp_num_cpus * UTIL_TOLLERANCE)
+		trouble_time = 11;
+	tasked = 0;
+	if(trouble_time && --trouble_time > 0)
+		kernel = inactive = 0;
+	else
+	{
+		struct task_struct *p;
+		struct mm_struct *mm;
+
+		kernel = (dentry_stat.nr_unused * sizeof(struct dentry) +
+			  inodes_stat.nr_unused * sizeof(struct inode))
+			  >> PAGE_SHIFT;
+		inactive = nr_inactive_pages;
+		write_lock_irq(&tasklist_lock);
+		++marker;
+		for_each_task(p)
+		{
+			task_lock(p);
+			if((mm = p->mm) && mm->mark != marker &&
+				time_before(jiffies, mm->last_memsort + 15*HZ))
+			{
+				tasked += mm->private_unused;
+				mm->mark = marker;
+			}
+			task_unlock(p);
+		}
+		write_unlock_irq(&tasklist_lock);
+	}
+	count = nr_free_pages() + kernel + inactive + tasked;
+	if(count >= num_physpages)	/* whatever went wrong... */
+		count = num_physpages - 1;
+	if(count < 0)
+		count = 0;
+	latest_free_mem = count;
+}
+
+static inline int
+sort_interval(int initial)
+{
+	if(latest_free_mem < pages_to_keep_free)
+		return(initial ? 0 : 3*HZ);
+	else if(latest_free_mem < 2 * pages_to_keep_free)
+		return(initial ? 2*HZ : 4*HZ);
+	else if(latest_free_mem < 4 * pages_to_keep_free)
+		return(initial ? 4*HZ : 8*HZ);
+	else
+		return(10*HZ);
+}
+
+/*
+ * sort pages into 3 piles: "used", "unused" and "swapped"
+ * plus another distinction for unused pages not otherwise accounted for
+ */
+void
+sort_and_age_pages(struct mm_struct *mm)
+{
+	int used = 0, unused = 0, swapped = 0, private_unused = 0;
+	int need_flush = 0;
+	register struct vm_area_struct *vma;
+	pgd_t *pgdir;
+	pmd_t *pmdir;
+	pte_t *pte;
+	struct page *page;
+	unsigned long addr, start, pgd_end, pmd_end;
+	static int let_go = -1;
+	int interval = sort_interval(1);
+
+	if(!mm->last_memsort && interval)
+	{
+		if(!mm->used)
+			mm->used = (jiffies & 0xffff) ? : 0xffff;
+		if((u16)((jiffies & 0xffff) - mm->used) < interval)
+			return;
+	}
+	addr = 0;
+	loop:
+	if(let_go == -1)
+		let_go = sort_age_maxchunk;
+	spin_lock(&mm->page_table_lock);
+	for(vma = mm->mmap ; vma != NULL ; vma = vma->vm_next)
+	if(addr < vma->vm_end)
+	{
+		start = vma->vm_start;
+		if(start < addr)
+			start = addr;
+		pgdir = pgd_offset(mm, start);
+		for(addr = start ; addr < vma->vm_end ;
+			addr = pgd_end , pgdir++)
+		{
+			if(let_go-- == 0)
+			{
+				spin_unlock(&mm->page_table_lock);
+				current->policy |= SCHED_YIELD;
+				schedule();
+				goto loop;
+			}
+			pgd_end = (addr + PGDIR_SIZE) & PGDIR_MASK;
+			if(pgd_end > vma->vm_end)
+				pgd_end = vma->vm_end;
+			if(pgd_none(*pgdir) || pgd_bad(*pgdir))
+				continue;
+			pmdir = pmd_offset(pgdir, addr);
+			for(; addr < pgd_end ; addr = pmd_end , pmdir++)
+			{
+				pmd_end = (addr + PMD_SIZE) & PMD_MASK;
+				if(pmd_end > pgd_end)
+					pmd_end = pgd_end;
+				if(pmd_none(*pmdir) || pmd_bad(*pmdir))
+					continue;
+				pte = pte_offset(pmdir, addr);
+					page = pte_page(*pte);
+				for(; addr < pmd_end ; addr += PAGE_SIZE, pte++)
+	{
+		if(pte_none(*pte))
+			continue;
+		if(!pte_present(*pte))
+		{
+			swapped++;
+			continue;
+		}
+		page = pte_page(*pte);
+		if(!VALID_PAGE(page) || PageReserved(page))
+			continue;
+		if(PageActive(page))
+		{
+			used++;
+			continue;
+		}
+		if(!PageActive(page))
+		{
+			unused++;
+			continue;
+		}
+		if(time_before(jiffies, page->last_young + OLD_SECONDS * HZ))
+		{
+			used++;
+			continue;
+		}
+		if(ptep_test_and_clear_young(pte))
+		{
+			page->young = 1;
+			page->last_young = jiffies;
+			need_flush = 1;
+			used++;
+			continue;
+		}
+		unused++;
+		private_unused++;
+	}
+			}
+		}
+	}
+	if(need_flush)
+		flush_tlb_mm(mm);
+	spin_unlock(&mm->page_table_lock);
+	write_lock_irq(&tasklist_lock);
+	mm->used = used;
+	mm->unused = unused;
+	mm->swapped = swapped;
+	mm->private_unused = private_unused;
+	mm->last_memsort = jiffies ? : 1;
+	write_unlock_irq(&tasklist_lock);
+}
+
+#define	SORT_AGE_MAGIC		2490368
+
+int
+mosix_mem_daemon(void *nothing)
+{
+	struct task_struct *p;
+	struct mm_struct *mm;
+	struct mm_struct **mms, **newmms;
+	unsigned int i, n;
+	int mmno = 100;
+	unsigned need_increase = 0;
+	int interval;
+
+	common_daemon_setup("memsorter", 0);
+	neutralize_my_load(1);
+	if(!(mms = (struct mm_struct **)kmalloc(mmno * sizeof(mms[0]),
+								GFP_KERNEL)))
+		panic("no mem for mms");
+	pages_to_keep_free = num_physpages / KEEP_FREE_PORTION;
+	if(pages_to_keep_free > MAX_PAGES_TO_KEEP_FREE)
+		pages_to_keep_free = MAX_PAGES_TO_KEEP_FREE;
+	compute_freemem();
+
+	/* "sort_and_age_pages" can take very long for large memories:
+	 * we must therefore allow other processes to take over at least
+	 * about every millisecond.
+	 */
+	sort_age_maxchunk = loops_per_jiffy / SORT_AGE_MAGIC;
+	if(!sort_age_maxchunk)	/* very slow processors */
+		sort_age_maxchunk = 1;
+	while (1)
+	{
+		current->state = TASK_INTERRUPTIBLE;
+		schedule_timeout(mosadmin_mode_quiet ? 100 * HZ : HZ);
+		if(current->sigpending)
+			flush_signals(current);
+		loop:
+                if (!PE)
+			wait_for_mosix_configuration(NULL);
+		if(mosadmin_mode_quiet)
+			continue;
+		compute_freemem();
+		interval = sort_interval(0);
+		n = 0;
+		write_lock_irq(&tasklist_lock);
+		++marker;
+		for_each_task(p)
+		if(!(p->mosix.stay & DSTAY_PER_MM))
+		{
+			task_lock(p);
+			mm = p->mm;
+			if((mm = p->mm) && mm != &init_mm && mm->mark != marker
+				&& time_before(mm->last_memsort + interval,
+								jiffies))
+			{
+				if(n >= mmno)
+					need_increase = 1;
+				else
+				{
+					atomic_inc(&mm->mm_users);
+					mms[n++] = mm;
+					mm->mark = marker;
+				}
+			}
+			task_unlock(p);
+		}
+		write_unlock_irq(&tasklist_lock);
+		for(i = 0 ; i < n ; i++)
+		{
+			mm = mms[i];
+			if(atomic_read(&mm->mm_realusers) > 0)
+				sort_and_age_pages(mm);
+			mmput(mm);
+		}
+		if(need_increase)
+		{
+			if((newmms = (struct mm_struct **)kmalloc(
+				(mmno + 50) * sizeof(mms[0]), GFP_KERNEL)))
+			{
+				kfree(mms);
+				mms = newmms;
+				mmno += 50;
+			}
+			need_increase = 0;
+			goto loop;
+		}
+		wake_up_interruptible(&kswapd_wait);
+	}
+}
+
+#if 0
+/* needed once-only to calibrate the "sort_age_maxchunk" calculation */
+/* not bothering using locks here, since we are only called from the debugger */
+int
+calibrate_sort_age(int pid)
+{
+	int sv = sort_age_maxchunk;
+	struct task_struct *p = find_task_by_pid(pid);
+	struct mm_struct *mm;
+	unsigned int chunks = 0;
+	register struct vm_area_struct *vma;
+	unsigned long addr, pgd_end;
+	__typeof__ (jiffies) before;
+	int milli, magic;
+	int i;
+
+	if(!p || !(mm = p->mm))
+	{
+		printk("No PID %d\n", pid);
+		return(0);
+	}
+
+	for(vma = mm->mmap ; vma != NULL ; vma = vma->vm_next)
+	for(addr = vma->vm_start ; addr < vma->vm_end ; addr = pgd_end)
+	{
+		chunks++;
+		pgd_end = (addr + PGDIR_SIZE) & PGDIR_MASK;
+		if(pgd_end > vma->vm_end)
+			pgd_end = vma->vm_end;
+	}
+	printk("%d chunks: starting 1000 times...", chunks);
+	sort_age_maxchunk = 0x7fffffff;	/* unlimit */
+	if(!mm->last_memsort)
+		mm->last_memsort = 1;
+	sti();
+	before = jiffies;
+	for(i = 0 ; i < 1000 ; i++)
+		sort_and_age_pages(mm);
+	milli = (jiffies - before) * 1000 / HZ;
+	printk("%d miliseconds, ", milli);
+	sort_age_maxchunk = sv;
+	if(milli < 100)
+	{
+		printk("That was too quick -- try a larger process!\n");
+		return((int)milli);
+	}
+	magic = loops_per_jiffy / (chunks * 1000 / milli);
+	printk("SORT_AGE_MAGIC=%d\n", magic);
+	return(magic);
+}
+#endif /* MOSIX_ONCE_ONLY */
diff -Naur --exclude=CVS --exclude=configs linux/hpc/hpcadmin.c linux-openmosix/hpc/hpcadmin.c
--- linux/hpc/hpcadmin.c	1970-01-01 01:00:00.000000000 +0100
+++ linux-openmosix/hpc/hpcadmin.c	2003-04-09 00:43:23.000000000 +0200
@@ -0,0 +1,350 @@
+/* Changes since Feb 12, 2002 copyright by Moshe Bar
+ * Copyright (C) 2000, 2001, Amnon Barak (amnon@cs.huji.ac.il)
+ *
+ * Permission to use this software is hereby granted under the terms of the
+ * GNU General Public License, as published by the Free Software Foundation.
+ *
+ * Author(s): Moshe Bar, Amnon Shiloh.
+ */
+#include <linux/config.h>
+#include <linux/hpcctl.h>
+#include <linux/hpc.h>
+#include <asm/hardirq.h>
+#include <asm/softirq.h>
+#include <linux/interrupt.h>
+#include <linux/smp_lock.h>
+#include <linux/mm.h>
+#include <hpc/routines.h>
+#include <hpc/defs.h>
+#include <hpc/debug.h>
+#ifdef CONFIG_MOSIX_FS
+#include <linux/mfs.h>
+#endif /* CONFIG_MOSIX_FS */
+
+int mosadmin_mode_stay;
+int mosadmin_mode_lstay;
+int mosadmin_mode_block;
+int mosadmin_mode_quiet;
+int mosadmin_mode_nomfs;
+int mosadmin_gateways;
+
+int backed_block;
+int backed_lstay;
+
+char bootexpel, expel_progress;
+static int in_bring, in_expel;
+
+int
+admin_set_mode(int mode, int on)
+{
+	int *m;
+
+	lock_mosix();
+	switch(mode)
+	{
+	case DS_STAY:
+		m = &mosadmin_mode_stay;
+		break;
+	case DS_LSTAY:
+		m = in_bring ? &backed_lstay : &mosadmin_mode_lstay;
+		break;
+	case DS_BLOCK:
+		m = in_expel ? &backed_block : &mosadmin_mode_block;
+		break;
+	case DS_QUIET:
+		m = &mosadmin_mode_quiet;
+		break;
+	case DS_NOMFS:
+		m = &mosadmin_mode_nomfs;
+		break;
+	default:
+		panic("admin_set_unknown_mode");
+		/*NOTREACHED*/
+	}
+	on = (on != 0);	/* sanity */
+	if(on == *m)
+	{
+		unlock_mosix();
+		return(0);
+	}
+	if(on)
+		switch (mode)
+		{
+		case DS_STAY:
+			printk(KERN_NOTICE "openMosix: Automatic process-migration from this node disabled.\n");
+			break;
+		case DS_LSTAY:
+			printk(KERN_NOTICE "openMosix: Auto-migration of local-processes from this node disabled.\n");
+			break;
+		case DS_BLOCK:
+			printk(KERN_NOTICE "openMosix: This node will not accept further guest-processes.\n");
+			break;
+		case DS_QUIET:
+			printk(KERN_NOTICE "openMosix: Automatic load-dissemination stopped.\n");
+			break;
+		case DS_NOMFS:
+			printk(KERN_NOTICE "openMosix: This node will stop providing MFS services.\n");
+			break;
+		}
+	else
+	{
+		switch(mode)
+		{
+		case DS_STAY:
+			if(in_bring ? backed_lstay:mosadmin_mode_lstay)
+				printk(KERN_NOTICE "openMosix: Auto-migration of guest-processes from this node re-enabled.\n");
+			else
+				printk(KERN_NOTICE "openMosix: Auto-migration from this node re-enabled.\n");
+			break;
+		case DS_LSTAY:
+			if(mosadmin_mode_stay)
+				printk(KERN_NOTICE "openMosix: Once auto-migration is enabled, local-processes may migrate as well.\n");
+			else
+				printk(KERN_NOTICE "openMosix: Auto-migration of local-processes from this node re-enabled.\n");
+			break;
+		case DS_BLOCK:
+			printk(KERN_NOTICE "openMosix: guest-processes now accepted again.\n");
+			break;
+		case DS_QUIET:
+			printk(KERN_NOTICE "openMosix: Automatic load-gossipping resumed.\n");
+			break;
+		case DS_NOMFS:
+			printk(KERN_NOTICE "openMosix: This node  may now provide oMFS services.\n");
+			break;
+		}
+	}
+	*m = on;
+	unlock_mosix();
+#ifdef CONFIG_MOSIX_FS
+	if(mode == DS_NOMFS)
+		mfs_change_pe();
+#endif /* CONFIG_MOSIX_FS */
+	return (0);
+}
+
+int
+admin_get_mode(int mode)
+{
+	int ret;
+
+	switch(mode)
+	{
+	case DS_STAY:
+		return(mosadmin_mode_stay);
+	case DS_LSTAY:
+		lock_mosix();
+		ret = in_bring ? backed_lstay : mosadmin_mode_lstay;
+		unlock_mosix();
+		return(ret);
+	case DS_BLOCK:
+		lock_mosix();
+		ret = in_expel ? backed_block : mosadmin_mode_block;
+		unlock_mosix();
+		return(ret);
+	case DS_QUIET:
+		return(mosadmin_mode_quiet);
+	case DS_NOMFS:
+		return(mosadmin_mode_nomfs);
+	}
+	return (-EINVAL);
+}
+
+int
+my_mosix_status(void)
+{
+	int s = DS_MOSIX_UP;
+
+	if(mosix_config_get_pe())
+		s |= DS_MOSIX_DEF;
+	if(mosadmin_mode_stay)
+		s |= DS_STAY;
+	lock_mosix();
+	if(in_bring ? backed_lstay : mosadmin_mode_lstay)
+		s |= DS_LSTAY;
+	if(in_expel ? backed_block : mosadmin_mode_block)
+		s |= DS_BLOCK;
+	unlock_mosix();
+	if(mosadmin_mode_quiet)
+		s |= DS_QUIET;
+	if(mosadmin_mode_nomfs)
+		s |= DS_NOMFS;
+	return(s);
+}
+
+int
+expel(int boot)
+{
+	unsigned int left = 0, oleft;
+	unsigned int round = 0;
+	struct task_struct *p;
+	int err = 0;
+
+	if(boot)
+	{
+		if(current->mosix.dflags & DREMOTE)
+			printk("Foops: cannot expel myself.\n");
+
+		tasklist_lock = RW_LOCK_UNLOCKED;
+	}
+	else
+	{
+		lock_mosix();
+		if(in_expel)
+		{
+			unlock_mosix();
+			return(-EBUSY);
+		}
+		in_expel = 1;
+	}
+	backed_block = mosadmin_mode_block;
+	mosadmin_mode_block = 1;
+	if(!boot)
+		unlock_mosix();
+	while(1)
+	{
+		oleft = left;
+		left = 0;
+		read_lock(&tasklist_lock);
+		for_each_task(p)
+		if((p->mosix.dflags & DREMOTE) && p != current &&
+			!(p->mosix.dflags & DFINISHED))
+		{
+			if(boot)
+				mosix_do_add_to_whereto(p, MUSTGOHOME);
+			else
+				mosix_add_to_whereto(p, MUSTGOHOME);
+			if(p->mosix.deppe != PE) /* don't count cheaters */
+				left++;
+		}
+		read_unlock(&tasklist_lock);
+		if(!left)
+		{
+			if(boot && round)
+				printk("Done. ");
+			else if(!backed_block)
+				printk(KERN_NOTICE "openMosix: "
+					"All guest processes evacuated and"
+					" no further guests allowed in\n");
+			break;
+		}
+		if(boot && round++ == 0)
+		{
+			int this_cpu = smp_processor_id();
+
+			printk("Expelling...");
+			bootexpel = 1;
+			cli();
+			if(local_irq_count(this_cpu))
+			{
+				local_irq_count(this_cpu)--;
+#ifdef CONFIG_SMP
+				release_irqlock(this_cpu);
+#endif /* CONFIG_SMP */
+			}
+			while(in_softirq())
+				local_bh_enable();
+			sti();
+		}
+		if(boot)
+			printk("%d ", left);
+		set_current_state(TASK_INTERRUPTIBLE);
+		schedule_timeout(HZ);
+		if(signal_pending(current))
+		{
+			if(boot) /* do not worry about locking */
+				flush_signals(current);
+			else
+			{
+				lock_mosix();
+				mosadmin_mode_block = backed_block;
+				unlock_mosix();
+				in_expel = 0;
+				return(-EINTR);
+			}
+		}
+		if((boot && expel_progress) || left < oleft)
+			round = 1;
+		expel_progress = 0;
+		if(round == 100)
+		{
+			printk("Giving up\n");
+			lock_mosix();
+			mosadmin_mode_block = backed_block;
+			unlock_mosix();
+			err = -EINTR;
+			break;
+		}
+	}
+	if(!boot)
+	{
+		lock_mosix();
+		in_expel = 0;
+		unlock_mosix();
+	}
+	return(err);
+}
+
+int
+bring(void)
+{
+	register struct task_struct *p, *w = NULL;
+	unsigned int left;
+	int err = -EBUSY;
+
+	lock_mosix();
+	if(in_bring)
+	{
+		unlock_mosix();
+		return(-EBUSY);
+	}
+	in_bring = 1;
+	backed_lstay = mosadmin_mode_lstay;
+	mosadmin_mode_lstay = 1;
+	unlock_mosix();
+	while(1)
+	{
+		left = 0;
+		w = NULL;
+		read_lock(&tasklist_lock);
+		for_each_task(p)
+		if((p->mosix.dflags & DDEPUTY) ||
+			(p->mosix.whereto && !(p->mosix.dflags & DREMOTE)))
+		{
+			mosix_add_to_whereto(p, MUSTGOHOME);
+			if(p->mosix.deppe != PE) /* don't count cheating_for_test */
+			{
+				left++;
+				if(!w)
+				{
+					w = p;
+					get_task_struct(w);
+				}
+			}
+		}
+		read_unlock(&tasklist_lock);
+		if(!left)
+		{
+			if(!backed_lstay)
+				printk(KERN_NOTICE "openMosix: "
+					"All local processes brought home"
+					" and will not auto-migrate away\n");
+			err = 0;
+			break;
+		}
+		tell_process(w, DREQ_HOMEWAKE);
+		interruptible_sleep_on_timeout(mos_to_waitp(&w->mosix), HZ);
+		free_task_struct(w);
+		if(signal_pending(current))
+		{
+			lock_mosix();
+			mosadmin_mode_lstay = backed_lstay;
+			unlock_mosix();
+			err = -EINTR;
+			break;
+		}
+	}
+	lock_mosix();
+	in_bring = 0;
+	unlock_mosix();
+	return(err);
+}
